<template>
  <h1>HTML reset</h1>

  <rui-alert variant="info">
    Note that all elements are not styled/reset. Please
    <a href="https://gitlab.com/experimentslabs/garden-party/rise-ui/-/issues/new" target="_blank" rel="noopener noreferrer">open an issue</a>
    if you need one.
  </rui-alert>

  <table>
    <tbody>
      <template v-for="(list, category) in templates" :key="category">
        <tr>
          <th colspan="2" class="-pvl">{{ category }}</th>
        </tr>
        <tr v-for="(html, tag) in list" :key="tag">
          <td><code>{{ tag }}</code></td>
          <td v-html="html" /> <!-- eslint-disable-line vue/no-v-html -->
        </tr>
      </template>
    </tbody>
  </table>
</template>

<script>
export default {
  name: 'HtmlResetView',
  data () {
    return {
      templates: {
        'Inline elements': {
          a: '<a href="#">Anchor link</a>, <a href="/something">Internal link</a> and <a href="https://garden-party.io">External link</a>',
          img: '<img src="https://picsum.photos/200" alt="random picture">',
          span: 'Here is a simple <span>span</span>.',
          em: 'Text with <em>emphasis</em>.',
          i: 'Deprecated <i>italics</i>.',
          b: 'Deprecated <b>bold</b>',
          strong: 'Text with more <strong>emphasis</strong>',
          mark: '<mark>Notice me!</mark>',
          s: 'Some <s>incorrect/inaccurate/irrelevant</s> text',
          del: 'Some <del>deleted</del> text',
          sub: 'H<sub>2</sub>O',
          small: 'Used to represent the <small>small print</small> of a document.',
          address: '<address>Main street 67</address>',
          cite: 'For more monsters, see <cite>The Monster Book of Monsters</cite>.',
          sup: 'x<sup>2</sup>',
          q: '<q>Me?</q>, she said.',
          time: '<time datetime="2020-05-23" pubdate>published on 23-05-2020</time>.',
          code: '<code>something</code>',
          kbd: '<kbd>Ctrl</kbd> + <kbd>a</kbd>',
          // audio: '',
          // video: '',
        },
        'Block elements': {
          p: '<p>A paragraph</p>',
          blockquote: '<blockquote>The blockquote element indicates an extended quotation.</blockquote>',
          details: `<details>
              <summary>Html Cheat Sheet</summary>
              <p>Inline elements</p>
              <p>Block elements</p>
            </details>`,
          ul: `<ul>
          <li>I'm an item</li>
          <li>I'm another item</li>
        </ul>`,
          ol: `<ol>
          <li>I'm the first item</li>
          <li>I'm the second item</li>
        </ol>`,
          dl: `<dl>
          <dt>A Term</dt>
          <dd>Definition of a term</dd>
          <dt>Another Term</dt>
          <dd>Definition of another term</dd>
        </dl>`,
          hr: '<hr>',
          h1: '<h1>This is Heading 1</h1>',
          h2: '<h2>This is Heading 2</h2>',
          h3: '<h3>This is Heading 3</h3>',
          h4: '<h4>This is Heading 4</h4>',
          h5: '<h5>This is Heading 5</h5>',
          h6: '<h6>This is Heading 6</h6>',
        },
        'Form elements': {
          fieldset: `
            <fieldset>
              <legend>Legend tag</legend>
              Fieldset content
            </fieldset>
          `,
          form: '<form>Form content</form>',
          'input type=button': '<div><input type="button" value="Button"></div>',
          'input type=checkbox': '<div><input type="checkbox"> <input type="checkbox" checked></div>',
          'input type=color': '<div><input type="color"></div>',
          'input type=date': '<div><input type="date"></div>',
          'input type=datetime': '<div><input type="datetime-local"></div>',
          'input type=email': '<div><input type="email"></div>',
          'input type=file': '<div><input type="file"></div>',
          'input type=hidden': '<div><input type="hidden"></div>',
          'input type=image': '<div><input type="image" alt="Your avatar"></div>',
          'input type=month': '<div><input type="month"></div>',
          'input type=number': '<div><input type="number"></div>',
          'input type=password': '<div><input type="password"></div>',
          'input type=radio': '<div><input type="radio" name="doc_input"> <input type="radio" name="doc_input" checked></div>',
          'input type=range': '<div><input type="range"></div>',
          'input type=reset': '<div><input type="reset" value="Reset"></div>',
          'input type=search': '<div><input type="search"></div>',
          'input type=submit': '<div><input type="submit" value="Submit"></div>',
          'input type=tel': '<div><input type="tel"></div>',
          'input type=text': '<div><input type="text"></div>',
          'input type=time': '<div><input type="time"></div>',
          'input type=url': '<div><input type="url"></div>',
          'input type=week': '<div><input type="week"></div>',
          'input placeholder=': '<div><input type="text" placeholder="Type your name"></div>',
          // Modifiers
          'input:required': '<input type="text" required>',
          'input:disabled': '<input type="text" value="Value" disabled>',
          'input:readonly': '<input type="text" value="Value" readonly >',
          'input:invalid': '<input type="email" value="invalid_email@">',
          label: '<label>Content</label>',
          legend: '<legend>Content</legend>',
          'meter, 0%': '<meter min="0" max="100" low="33" high="66" optimum="80" value="0">at 0/100</meter>',
          'meter, 10%': '<meter min="0" max="100" low="33" high="66" optimum="80" value="10">at 10/100</meter>',
          'meter, 50%': '<meter min="0" max="100" low="33" high="66" optimum="80" value="50">at 50/100</meter>',
          'meter, 100%': '<meter min="0" max="100" low="33" high="66" optimum="80" value="100">at 100/100</meter>',
          output: '<output>Value</output>',
          'progress, 0%': '<progress max="100" value="0">0%</progress>',
          'progress, 10%': '<progress max="100" value="10">10%</progress>',
          'progress, 50%': '<progress max="100" value="50">50%</progress>',
          'progress, 100%': '<progress max="100" value="100">100%</progress>',
          select: `
            <select>
              <option value="1">Option 1</option>
              <option value="2">Option 2</option>
              <option value="3">Option 3</option>
              <optgroup label="Sub-group">
                <option value="3">Option 4</option>
              </optgroup>
            </select>
          `,
          textarea: '<textarea></textarea>',
        },
      },
    }
  },
  created () {
    this.$setTitle('HTML reset')
  },
}
</script>
